#ifndef CONTROLWINDOW_H
#define CONTROLWINDOW_H

#include <QtGui>
#include <QDialog>
#include "ui_controlWindow.h"
#include "types.h"

class xvsMainWindow;
class PlotWidget;

class ControlWindow : public QDialog, public Ui::ControlWindow
{
    Q_OBJECT
public:
    ControlWindow(QWidget *parent = 0);
    void updateData(xytVector data);
    void updateDataIndex(int timeIndex);
    void showCurrentData();

private slots:
    void labelOn();
    void labelOff();
    void colorChanged(int color);
    void formatChanged(int format);
    void allLabelsOn();
    void allLabelsOff();
    void pushOntoStack();
    void changeDecimals(int d);

private:
    QList<QRadioButton *> labelList;
    int findSelectedLabel();
    xytVector myData;
    int myTime;
    int myDecimals;

signals:
    void pushOntoStackSignal(plotLimits p);
    void labelToggled(int label, bool toggle);
    void labelColorChanged(int label, int color);
    void labelFormatChanged(int label, int format);
};

#endif // CONTROLWINDOW_H
