#ifndef      F77_INTRINSICS_DEF
#define      F77_INTRINSICS_DEF

#if defined INTEL_8_OR_LATER
#define D_ABS    for_d_abs_a
#define D_ACOS   for_d_acos_a
#define D_ASIN   for_d_asin_a
#define D_ATAN   for_d_atan_a
#define D_ATAN2  for_d_atan2_a
#define D_CONJG  for_d_conjg_a
#define D_COS    for_d_cos_a
#define D_COSH   for_d_cosh_a
#define D_DIM    for_d_dim_a
#define D_EXP    for_d_exp_a
#define D_LOG    for_d_log_a
#define D_LG10   for_d_log10_a
#define D_MOD    for_d_mod_a
#define D_PROD   for_d_prod_a
#define D_SIGN   for_d_sign_a
#define D_SIN    for_d_sin_a
#define D_SINH   for_d_sinh_a
#define D_SQRT   for_d_sqrt_a
#define D_TAN    for_d_tan_a
#define D_TANH   for_d_tanh_a
#elif defined GFORTRAN42
#define D_ABS    specific__abs_r8
#define D_ACOS   specific__acos_r8
#define D_ASIN   specific__asin_r8
#define D_ATAN   specific__atan_r8
#define D_ATAN2  specific__atan2_r8
#define D_CONJG  specific__conjg_r8
#define D_COS    specific__cos_r8
#define D_COSH   specific__cosh_r8
#define D_DIM    specific__dim_r8
#define D_EXP    specific__exp_r8
#define D_LOG    specific__log_r8
#define D_LG10   specific__log10_r8
#define D_MOD    specific__mod_r8
#define D_PROD   specific__prod_r8
#define D_SIGN   specific__sign_r8
#define D_SIN    specific__sin_r8
#define D_SINH   specific__sinh_r8
#define D_SQRT   specific__sqrt_r8
#define D_TAN    specific__tan_r8
#define D_TANH   specific__tanh_r8
#elif defined GFORTRAN43
#define D_ABS    _gfortran_specific__abs_r8
#define D_ACOS   _gfortran_specific__acos_r8
#define D_ASIN   _gfortran_specific__asin_r8
#define D_ATAN   _gfortran_specific__atan_r8
#define D_ATAN2  _gfortran_specific__atan2_r8
#define D_CONJG  _gfortran_specific__conjg_r8
#define D_COS    _gfortran_specific__cos_r8
#define D_COSH   _gfortran_specific__cosh_r8
#define D_DIM    _gfortran_specific__dim_r8
#define D_EXP    _gfortran_specific__exp_r8
#define D_LOG    _gfortran_specific__log_r8
#define D_LG10   _gfortran_specific__log10_r8
#define D_MOD    _gfortran_specific__mod_r8
#define D_PROD   _gfortran_specific__prod_r8
#define D_SIGN   _gfortran_specific__sign_r8
#define D_SIN    _gfortran_specific__sin_r8
#define D_SINH   _gfortran_specific__sinh_r8
#define D_SQRT   _gfortran_specific__sqrt_r8
#define D_TAN    _gfortran_specific__tan_r8
#define D_TANH   _gfortran_specific__tanh_r8
#elif defined GFORTRAN44
#define D_ABS    _gfortran_specific__abs_r8
#define D_ACOS   _gfortran_specific__acos_r8
#define D_ASIN   _gfortran_specific__asin_r8
#define D_ATAN   _gfortran_specific__atan_r8
#define D_ATAN2  _gfortran_specific__atan2_r8
#define D_CONJG  _gfortran_specific__conjg_r8
#define D_COS    _gfortran_specific__cos_r8
#define D_COSH   _gfortran_specific__cosh_r8
#define D_DIM    _gfortran_specific__dim_r8
#define D_EXP    _gfortran_specific__exp_r8
#define D_LOG    _gfortran_specific__log_r8
#define D_LG10   _gfortran_specific__log10_r8
#define D_MOD    _gfortran_specific__mod_r8
#define D_PROD   _gfortran_specific__prod_r8
#define D_SIGN   _gfortran_specific__sign_r8
#define D_SIN    _gfortran_specific__sin_r8
#define D_SINH   _gfortran_specific__sinh_r8
#define D_SQRT   _gfortran_specific__sqrt_r8
#define D_TAN    _gfortran_specific__tan_r8
#define D_TANH   _gfortran_specific__tanh_r8
#else
#define D_ABS    d_abs
#define D_ACOS   d_acos
#define D_ASIN   d_asin
#define D_ATAN   d_atan
#define D_ATAN2  d_atan2
#define D_CONJG  d_conjg
#define D_COS    d_cos
#define D_COSH   d_cosh
#define D_DIM    d_dim
#define D_EXP    d_exp
#define D_LOG    d_log
#define D_LG10   d_lg10
#define D_MOD    d_mod
#define D_PROD   d_prod
#define D_SIGN   d_sign
#define D_SIN    d_sin
#define D_SINH   d_sinh
#define D_SQRT   d_sqrt
#define D_TAN    d_tan
#define D_TANH   d_tanh
#endif

extern     double  D_ABS();
extern     double  D_ACOS();
extern     double  D_ASIN();
extern     double  D_ATAN();
extern     double  D_ATAN2();
extern     double  D_CONJG();
extern     double  D_COS();
extern     double  D_COSH();
extern     double  D_DIM();
extern     double  D_EXP();
extern     double  D_LOG();
extern     double  D_LG10();
extern     double  D_MOD();
extern     double  D_PROD();
extern     double  D_SIGN();
extern     double  D_SIN();
extern     double  D_SINH();
extern     double  D_SQRT();
extern     double  D_TAN();
extern     double  D_TANH();

#endif
