#ifndef XYDEFS
#define XYDEFS

#include <stdlib.h>
#include "include/xy_types.h"

extern      PXYDVEC     make_XYDVEC(int);
extern      PXYDVEC     free_XYDVEC(PXYDVEC);
extern      PXYDVEC     dump_XYDVEC(PXYDVEC,char *);
extern      PXYDVEC     test_XYDVEC(int);
extern      PXYDVEC     clip_XYDVEC(PXYDVEC,DQUAD);

extern      PXYDVBIND   make_XYDVBIND();
extern      void        free_XYDVBIND(PXYDVBIND p);
extern      PXYDVBIND   link_PXYDVBIND(PXYDVBIND p1,PXYDVBIND p2);
extern      PXYDVBIND   clone_XYDVLIST(PXYDVBIND p);
extern      PXYDVBIND_VECN  make_PXYDVBIND_VECN(int n);
extern      void        free_PXYDVBIND_VECN(PXYDVBIND_VECN the);
extern      void        free_XYDVLIST(PXYDVBIND);
extern      PXYDVBIND   double_PXYDVBIND(PXYDVBIND);
extern      PXYDVBIND   copy_PXYDVBIND(PXYDVBIND p);
extern      PXYDVBIND   expand_PXYDVBIND_nfold(PXYDVBIND,int);
extern      PXYDVBIND   expand_PXYDVBIND_by_n(PXYDVBIND,int);
extern      PXYDVBIND   resize_PXYDVBIND_to_n(PXYDVBIND p,int newn);

extern      int         n_PXYDVBIND(PXYDVBIND);
extern      PXYDVBIND   nth_PXYDVBIND(PXYDVBIND phead,int n);
extern      double      xmin_PXYDVBIND(PXYDVBIND p);
extern      double      xmax_PXYDVBIND(PXYDVBIND p);
extern      double      ymin_PXYDVBIND(PXYDVBIND p);
extern      double      ymax_PXYDVBIND(PXYDVBIND p);

extern      PXYDVBIND   merge_pxydv(PXYDVBIND,PXYDVBIND);

extern      int         fuzz_equal(double,double,double);
extern      int         insert_fuzz_equal(double,double);

extern      PXYDVEC     thin_XYDVEC(PXYDVEC,double);
extern      PXYDVBIND   thin_PXYDVBIND(PXYDVBIND,double);

extern      PXYDVBIND   mean_PXYDVBIND(PXYDVBIND);

extern      DVEC        make_tvec(PXYDVBIND);
extern      DVEC        make_ith_yvec(PXYDVBIND p,int ith);

extern      int         compatible_PXYDVBIND_lists_t(PXYDVBIND,PXYDVBIND);
extern      int         compatible_PXYDVBIND_lists_data_n(PXYDVBIND,PXYDVBIND);

extern      PXYTAGVEC   make_XYTAGVEC(int);
extern      PXYTAGVEC   free_XYTAGVEC(PXYTAGVEC);

extern      PXYDVEC     split_XYDVEC_by_x_sense(PXYDVEC in,int *pnout);
extern      void        free_split_XYDVEC(PXYDVEC the,int nvec);
#endif
