#include "types.h"
using namespace std;

double getDouble(double def, QString str)
{
    double r=def;
    r= QInputDialog::getDouble(0, "Get double",str,def);
    return r;
}

//Qthread contruction that returns when the specified number of widgets has been selected
getSelectedWidgets::getSelectedWidgets(int need)
{
    numNeeded = need;
    numSelected =0;
}
void getSelectedWidgets::run()
{
    while (numSelected != numNeeded) {}
    return;
}
void getSelectedWidgets::changeSelected(int n)
{
    numSelected = n;
}

//xytVector constructor
xytVector::xytVector(QString n)
{
    name = n;
}

void xytVector::setUniformX(QList<double> list, int timeSteps)
{
    X.clear();
    for (int i=0;i<timeSteps;i++)
    {
        X.append(list);
    }
}

void xytVector::x_log_c_plus_x(double c)
{
    for (int i=0;i<X.count();i++){
        for (int j=0;j<X.at(i).count();j++){
            X[i][j] = log(X.at(i).at(j) +c);
        }//end for loop (i)
    }
}
void xytVector::x_times_y()
{
    for (int i=0;i<Y.count();i++){
        for (int j=0; j<X.at(i).count(); j++) {
            Y[i][j] = X.at(i).at(j) * Y.at(i).at(j);
        }//end for loop (j)
    }//end for loop (i)
}
void xytVector::x_p(double p)
{
    for (int i=0;i<X.count();i++){
        for (int j=0;j<X.at(i).count();j++){
            X[i][j] = pow(X.at(i).at(j),p);
        }//end for loop (i)
    }
}
void xytVector::x_p_times_y(double p)
{
    for (int i=0;i<Y.count();i++){
        for (int j=0; j<X.at(i).count(); j++) {
            Y[i][j] = pow(X.at(i).at(j),p) * Y.at(i).at(j);
        }//end for loop (j)
    }//end for loop (i)
}
void xytVector::y_divide_x()
{
    for (int i=0;i<Y.count();i++){
        for (int j=0; j<X.at(i).count(); j++) {
            Y[i][j] = Y.at(i).at(j) / X.at(i).at(j);
        }//end for loop (j)
    }//end for loop (i)
}
void xytVector::y_p(double p)
{
    for (int i=0;i<Y.count();i++){
        for (int j=0; j<X.at(i).count(); j++) {
            Y[i][j] = pow(Y.at(i).at(j),p);
        }//end for loop (j)
    }//end for loop (i)
}

void xytVector::dy_dx()
{
    for (int i=0;i<Y.count();i++){
        double l = X.at(i).count()-1;
        QList<double> newY;
        newY.append(0.0); //placeholder for initial array value
        for (int j=1; j<l; j++) {
            newY.append( (Y.at(i).at(j+1) - Y.at(i).at(j-1) ) / (X.at(i).at(j+1)-X.at(i).at(j-1) )  );
        }//end for loop (j)
        newY[0] = newY.at(1) - ( newY.at(2)-newY.at(1) ); //approximate first array value
        newY.append(2*newY.at(l-1)- newY.at(l-2));        //approximate last array value
        Y[i]=newY;
    }//end for loop (i)
}

/*****************PlotSettings implementation********************/
//holds plot limit data
PlotSettings::PlotSettings()
{
    minX=0.0;
    maxX = 10.0;
    numXTicks =5;

    minY = 0.0;
    maxY = 10.0;
    numYTicks =5;
}
void PlotSettings::scroll(int dx, int dy)
{
    double stepX = spanX() / numXTicks;
    minX += dx * stepX;
    maxX += dx * stepX;

    double stepY = spanY() / numYTicks;
    minY += dy * stepY;
    maxY += dy * stepY;
}
void PlotSettings::info()
{
    cout << "minX  "<<minX << endl;
    cout << "minY  "<<minY << endl;
    cout << "maxX  "<<maxX << endl;
    cout << "maxY  "<<maxY << endl;

    cout << "spanX  "<<spanX()<<endl;
    cout << "spanY  "<<spanY()<<endl;

    cout << "numXTicks  "<<numXTicks<<endl;
    cout << "numYTicks  "<<numYTicks<<endl;
}
void PlotSettings::adjust()
{
    adjustAxis(minX,maxX,numXTicks);
    adjustAxis(minY,maxY,numYTicks);
}
void PlotSettings::adjustAxis(double &min, double &max, int &numTicks)
{
    const int MinTicks =4;
    double grossStep = (max-min) / MinTicks;
    double step = pow(10.0, floor(log10(grossStep)));

    if (5*step < grossStep) {
        step *= 5;
    } else if (2*step < grossStep){
        step *=2;
    }

    numTicks = int(ceil(max / step) - floor(min/step));
    if (numTicks < MinTicks) numTicks = MinTicks;

    if (fabs(min) < 1e-9) min = 0;
    else min = floor(min / step)*step;

    if (fabs(fabs(max)-1) < 1e-9) min = 0;
    else max = ceil(max / step) *step;
}
/****************End PlotSettings implementation****************/
